
void drawFront();
void drawBack();
void drawFrontSharp(GLfloat tt, GLfloat ttt[3], GLfloat t);
void drawValley();
void drawValley2();

GLfloat sharpThreshold = 45.0*3.1415928/180.0;
int sharpFlag = 0;
GLfloat offset_factor = 0.0, offset_units = 0.1;

void
drawSharps()
{
	GLfloat sharpColor[3] = {0.2,0.2,0.2};
  if (colorObjFlag == 0) glColorMask(GL_FALSE, GL_FALSE, GL_FALSE, GL_FALSE);
  glCullFace(GL_BACK);
  glEnable(GL_CULL_FACE);
  glDepthMask(GL_TRUE);  
  glColor4f(0.8f, 0.8f, 1.f, 1.0f); 
  drawFrontSharp(sharpThreshold, sharpColor, lineWidth);
  if(glGetError())
    printf("oops! Bad gl command after curobjSimple!\n");
  
  glColorMask(GL_TRUE, GL_TRUE, GL_TRUE, GL_TRUE);
  glPolygonMode(GL_BACK, GL_FILL);
  glDepthFunc(GL_LEQUAL);
  glDisable(GL_CULL_FACE);
  if (colorObjFlag == 0) glColor3f(0.5f, 0.f, 0.f); else glColor4f(0.f, 0.f, 0.f, 1.0f);
}

void
drawValley()
{
	GLfloat sharpColor[3] = {0.0,0.1,0.2};
	GLfloat valleyColor[3] = {1.0,1.0,1.0};
  //if (colorObjFlag == 0) glColorMask(GL_FALSE, GL_FALSE, GL_FALSE, GL_FALSE);
  // glCullFace(GL_BACK);
  //glEnable(GL_CULL_FACE);
  glCullFace(GL_NONE);
  glDisable(GL_CULL_FACE);
  glDepthMask(GL_TRUE);  
  drawFrontSharp(269.0*3.1415926/180.0, sharpColor, lineWidth );
  //drawFrontSharp(sharpThreshold, sharpColor );
  printf("sharpThreshold %f \n",sharpThreshold);
  drawFrontSharp(270*3.1415926/180.0-sharpThreshold, valleyColor, lineWidth*3 );
  if(glGetError())
    printf("oops! Bad gl command after curobjSimple!\n");
  
  glColorMask(GL_TRUE, GL_TRUE, GL_TRUE, GL_TRUE);
  glPolygonMode(GL_BACK, GL_FILL);
  glDepthFunc(GL_LEQUAL);
  glDisable(GL_CULL_FACE);
  if (colorObjFlag == 0) glColor3f(0.5f, 0.f, 0.f); else glColor4f(0.f, 0.f, 0.f, 1.0f);
}

void drawExtraStuff(GLfloat factor)
{
  int i,num;
  GLfloat temp[3];
  GLfloat normal[3], temp1[3], temp2[3];
  GLfloat eyeVec[3];
  GLfloat eyeT[3];// lightT[3];
  GLfloat colval[3];
  GLfloat dotval, eyeDist, orntFactor, cosAngle;
  GLfloat modelview_mat[16], iview[16], id_mat[16];

  num = CURRENT_MODEL;
 
  glDisable(GL_BLEND);
 
  //initShading();
  glGetFloatv(GL_MODELVIEW_MATRIX, modelview_mat);
  mat4Invert(modelview_mat, iview);
  mat4vec3Mult(iview, eye, eyeT);

  //draw the creases

  //glDisable(GL_CULL_FACE);
  glDepthFunc(GL_LEQUAL);
  glColor3f(1.0,0.0,1.0);

  /// vertex shift = v - cos*N + sin*EdgeNormal, where angle = angle - 90
  GLfloat cosThr = factor*lineWidth*cos(sharpThreshold); // negatine normal
  GLfloat sinThr = factor*lineWidth*sin(sharpThreshold);
  
  GLfloat vert0[3], vert1[3], vert2[3], scaledNormal[3];
  Vec3 N, E10, E21, E02, N10, N21, N02, N10sin, N21sin, N02sin, Ncos;
  Vec3 E10shift, E21shift, E02shift,E10L, E21L, E02L,E10R, E21R, E02R;
  GLfloat k, kShift = 0.1;

  for (i = 0; i < trisStruct[num].numTris; i ++) {


	vecAssign(trisStruct[num].tris[i].norm, N); // vecPrint(N,"N");
	vecAssign(vertStruct[num].verts[trisStruct[num].tris[i].vert[0]].d, vert0);
	vecAssign(vertStruct[num].verts[trisStruct[num].tris[i].vert[1]].d, vert1);
	vecAssign(vertStruct[num].verts[trisStruct[num].tris[i].vert[2]].d, vert2);
	vecSub( eyeT,trisStruct[num].tris[i].midpt, eyeVec);
    eyeDist = vecMagn(eyeVec);
    vecNormalize(eyeVec);
    cosAngle = vecDotProduct(eyeVec,N);
	if (cosAngle <=0) continue; // remove backfacing
    // if (cosAngle <  cosAngleThreshold) 
	{
      if (cosAngle < 0) cosAngle = - cosAngle;
      // orntFactor = (eyeDist/10.0)*(1.0/(cosAngle));
      orntFactor = (eyeDist/10.0)*(sqrt(1.0 - cosAngle*cosAngle) + kShift);
      k = orntFactor*scaleT;
      /*printf("eyeDist= %3.2f,cosAngle=%3.2f,sinAngle=%3.2f,ornF=%3.2f\n",*/
	     /*eyeDist,cosAngle,sqrt(1.0 - cosAngle*cosAngle),orntFactor);*/
      
      /* find edge and normal to edge in plane vectors */
      vecSub(vertStruct[num].verts[trisStruct[num].tris[i].vert[1]].d,vertStruct[num].verts[trisStruct[num].tris[i].vert[0]].d, E10);
      vecNormalize(E10);
      vecCross(E10, N, N10);
      vecNormalize(N10); // vecPrint(E10,"E10"); vecPrint(N10,"N10");
      
      vecSub(vertStruct[num].verts[trisStruct[num].tris[i].vert[2]].d,vertStruct[num].verts[trisStruct[num].tris[i].vert[1]].d, E21);
      vecNormalize(E21);
      vecCross(E21, N, N21);
      vecNormalize(N21);
      
      vecSub(vertStruct[num].verts[trisStruct[num].tris[i].vert[0]].d,vertStruct[num].verts[trisStruct[num].tris[i].vert[2]].d, E02);
      vecNormalize(E02);
      vecCross(E02, N, N02);
      vecNormalize(N02);

	  

	  vecScale(N,cosThr,Ncos);
	  vecScale(N10, sinThr, N10sin);
	  vecScale(N21, sinThr, N21sin);
	  vecScale(N02, sinThr, N02sin);
	  vecAdd(Ncos,N10sin,E10shift);
	  vecAdd(Ncos,N21sin,E21shift);
	  vecAdd(Ncos,N02sin,E02shift);
	  /* vecPrint(vert0,"vert0"); 
	  vecPrint(Ncos,"Ncos");
	  vecPrint(N10sin,"N10sin");
	  vecPrint(E10shift,"E10shift"); */

	  vecAdd(vert1, E10shift, E10L);
	  vecAdd(vert0, E10shift, E10R);
	  vecAdd(vert2, E21shift, E21L);
	  vecAdd(vert1, E21shift, E21R);
	  vecAdd(vert0, E02shift, E02L);
	  vecAdd(vert2, E02shift, E02R);

	  glBegin(GL_QUADS);
	  glVertex3fv(vert0);
	  glVertex3fv(E10R);
	  glVertex3fv(E10L);
	  glVertex3fv(vert1);

	  glVertex3fv(vert1);
	  glVertex3fv(E21R);
	  glVertex3fv(E21L);
	  glVertex3fv(vert2);

	  glVertex3fv(vert2);
	  glVertex3fv(E02R);
	  glVertex3fv(E02L);
	  glVertex3fv(vert0);
	  glEnd();
	} // end if front facing
  } //end for each triangle
}

void drawFront()
{
  int i,num;
  GLfloat temp[3];
  GLfloat normal[3], temp1[3], temp2[3];
  GLfloat eyeVec[3];
  GLfloat eyeT[3], lightT[3];
  GLfloat colval[3];
  GLfloat dotval, eyeDist, orntFactor, cosAngle;
  GLfloat modelview_mat[16], iview[16], id_mat[16];

  num = CURRENT_MODEL;
 
  glDisable(GL_BLEND);
 
  //initShading();
  glGetFloatv(GL_MODELVIEW_MATRIX, modelview_mat);
  mat4Invert(modelview_mat, iview);
  mat4vec3Mult(iview, eye, eyeT);
   
   
  /* if (maskShadeFrontFlag == 1) {
	  
	  glGetFloatv(GL_MODELVIEW_MATRIX, modelview_mat);
	  mat4Invert(modelview_mat, iview);
	  //matPrint(modelview_mat, "view mat");
	  //matPrint(iview, "iview");
	  mat4Mult(modelview_mat, iview, id_mat);
	  //matPrint(id_mat, "id_mat");
	  
	  mat4vec3Mult(iview, eye, eyeT);
	  mat4vec3Mult(iview, light, lightT,0);
	  //vecPrint(eyeT, "eyeT");
	  //vecPrint(lightT, "lightT");
  }*/
  //glColor3f(1.0,1.0,0.0);
  glBegin(GL_TRIANGLES);
  for (i = 0; i < trisStruct[num].numTris; i ++) {
	  /* if (maskShadeFrontFlag == 1) {
		  // implement Gooch lighting model
		  dotval = vecDotProduct(lightT, trisStruct[num].tris[i].norm);	
		  vecScale(kcool, (1.0 + dotval)/2.0, temp1);
		  vecScale(kwarm, 1.0 - (1.0 + dotval)/2.0, temp2);
		  vecAdd(temp1, temp2, colval);
		  glColor3fv(colval);
	  }*/

	  vecSub( eyeT,trisStruct[num].tris[i].midpt, eyeVec);
	  cosAngle = vecDotProduct(eyeVec,trisStruct[num].tris[i].norm);
	  if (cosAngle <=0) continue; // remove backfacing
	  
	  glVertex3fv(vertStruct[num].verts[trisStruct[num].tris[i].vert[0]].d);
	  glVertex3fv(vertStruct[num].verts[trisStruct[num].tris[i].vert[1]].d);
	  glVertex3fv(vertStruct[num].verts[trisStruct[num].tris[i].vert[2]].d);
  }
  glEnd();
  
  //if (sharpFlag) drawFrontSharp(sharpThreshold, 0, lineWidth);

  glEnable(GL_BLEND);
}


void drawBackSimple()
{

  int i,num;
  GLfloat eyeVec[3];
  GLfloat eyeT[3];
  GLfloat dotval, cosAngle;
  GLfloat modelview_mat[16], iview[16];

  num = CURRENT_MODEL;
 
  glDisable(GL_BLEND);
  glDisable(GL_CULL_FACE);
 
  //initShading();
  glGetFloatv(GL_MODELVIEW_MATRIX, modelview_mat);
  mat4Invert(modelview_mat, iview);
  mat4vec3Mult(iview, eye, eyeT);
   
   
  glColor3f(1.0,1.0,0.0);
  glBegin(GL_TRIANGLES);
  for (i = 0; i < trisStruct[num].numTris; i ++) {
	  vecSub( eyeT,trisStruct[num].tris[i].midpt, eyeVec);
	  cosAngle = vecDotProduct(eyeVec,trisStruct[num].tris[i].norm);
	  if (cosAngle >=0) continue; // remove frontfacing
	  
	  glVertex3fv(vertStruct[num].verts[trisStruct[num].tris[i].vert[0]].d);
	  glVertex3fv(vertStruct[num].verts[trisStruct[num].tris[i].vert[1]].d);
	  glVertex3fv(vertStruct[num].verts[trisStruct[num].tris[i].vert[2]].d);
  }
  glEnd();
}


void drawFrontSharp(GLfloat sharpThresholdLocal, GLfloat colorLocal[], GLfloat lineWidthLocal)
{
  int i,num;
  GLfloat temp[3];
  // GLfloat normal[3], temp1[3], temp2[3];
  GLfloat eyeVec[3];
  GLfloat eyeT[3], lightT[3];
  GLfloat colval[3];
  GLfloat dotval, eyeDist, orntFactor, cosAngle;
  GLfloat modelview_mat[16], iview[16], id_mat[16];

  num = CURRENT_MODEL;
 
  glDisable(GL_BLEND);
 
  //initShading();
  glGetFloatv(GL_MODELVIEW_MATRIX, modelview_mat);
  mat4Invert(modelview_mat, iview);
  mat4vec3Mult(iview, eye, eyeT);
  glColor3f(1.0,1.0,0.0);
  glBegin(GL_TRIANGLES);
  for (i = 0; i < trisStruct[num].numTris; i ++) {
	  glVertex3fv(vertStruct[num].verts[trisStruct[num].tris[i].vert[0]].d);
	  glVertex3fv(vertStruct[num].verts[trisStruct[num].tris[i].vert[1]].d);
	  glVertex3fv(vertStruct[num].verts[trisStruct[num].tris[i].vert[2]].d);
  }
  glEnd();
  
  //draw the creases

  glDisable(GL_CULL_FACE);
  glDepthFunc(GL_LEQUAL);
  glColor3fv(colorLocal);

  /// vertex shift = v - cos*N + sin*EdgeNormal, where angle = angle - 90
  GLfloat cosThr = -lineWidthLocal*cos(sharpThresholdLocal); // negative normal
  GLfloat sinThr = lineWidthLocal*sin(sharpThresholdLocal);
  
  GLfloat vert0[3], vert1[3], vert2[3], scaledNormal[3];
  Vec3 N, E10, E21, E02, N10, N21, N02, N10sin, N21sin, N02sin, Ncos;
  Vec3 E10shift, E21shift, E02shift,E10L, E21L, E02L,E10R, E21R, E02R;
  GLfloat k, kShift = 0.1;

  for (i = 0; i < trisStruct[num].numTris; i ++) {
	vecAssign(trisStruct[num].tris[i].norm, N); // vecPrint(N,"N");
	vecAssign(vertStruct[num].verts[trisStruct[num].tris[i].vert[0]].d, vert0);
	vecAssign(vertStruct[num].verts[trisStruct[num].tris[i].vert[1]].d, vert1);
	vecAssign(vertStruct[num].verts[trisStruct[num].tris[i].vert[2]].d, vert2);
	vecSub( eyeT,trisStruct[num].tris[i].midpt, eyeVec);
    eyeDist = vecMagn(eyeVec);
    vecNormalize(eyeVec);
    cosAngle = vecDotProduct(eyeVec,N);
	if (cosAngle <=0) continue; // remove backfacing
    // if (cosAngle <  cosAngleThreshold) 
	{
      if (cosAngle < 0) cosAngle = - cosAngle;
      // orntFactor = (eyeDist/10.0)*(1.0/(cosAngle));
      orntFactor = (eyeDist/10.0)*(sqrt(1.0 - cosAngle*cosAngle) + kShift);
      k = orntFactor*scaleT;
      /*printf("eyeDist= %3.2f,cosAngle=%3.2f,sinAngle=%3.2f,ornF=%3.2f\n",*/
	     /*eyeDist,cosAngle,sqrt(1.0 - cosAngle*cosAngle),orntFactor);*/
      
      /* find edge and normal to edge in plane vectors */
      vecSub(vertStruct[num].verts[trisStruct[num].tris[i].vert[1]].d,vertStruct[num].verts[trisStruct[num].tris[i].vert[0]].d, E10);
      vecNormalize(E10);
      vecCross(E10, N, N10);
      vecNormalize(N10); // vecPrint(E10,"E10"); vecPrint(N10,"N10");
      
      vecSub(vertStruct[num].verts[trisStruct[num].tris[i].vert[2]].d,vertStruct[num].verts[trisStruct[num].tris[i].vert[1]].d, E21);
      vecNormalize(E21);
      vecCross(E21, N, N21);
      vecNormalize(N21);
      
      vecSub(vertStruct[num].verts[trisStruct[num].tris[i].vert[0]].d,vertStruct[num].verts[trisStruct[num].tris[i].vert[2]].d, E02);
      vecNormalize(E02);
      vecCross(E02, N, N02);
      vecNormalize(N02);

	  

	  vecScale(N,cosThr,Ncos);
	  vecScale(N10, sinThr, N10sin);
	  vecScale(N21, sinThr, N21sin);
	  vecScale(N02, sinThr, N02sin);
	  vecAdd(Ncos,N10sin,E10shift);
	  vecAdd(Ncos,N21sin,E21shift);
	  vecAdd(Ncos,N02sin,E02shift);
	  /* vecPrint(vert0,"vert0"); 
	  vecPrint(Ncos,"Ncos");
	  vecPrint(N10sin,"N10sin");
	  vecPrint(E10shift,"E10shift"); */

	  vecAdd(vert1, E10shift, E10L);
	  vecAdd(vert0, E10shift, E10R);
	  vecAdd(vert2, E21shift, E21L);
	  vecAdd(vert1, E21shift, E21R);
	  vecAdd(vert0, E02shift, E02L);
	  vecAdd(vert2, E02shift, E02R);

	  glBegin(GL_QUADS);
	  glVertex3fv(vert0);
	  glVertex3fv(E10R);
	  glVertex3fv(E10L);
	  glVertex3fv(vert1);

	  glVertex3fv(vert1);
	  glVertex3fv(E21R);
	  glVertex3fv(E21L);
	  glVertex3fv(vert2);

	  glVertex3fv(vert2);
	  glVertex3fv(E02R);
	  glVertex3fv(E02L);
	  glVertex3fv(vert0);
	  glEnd();
	} // end if front facing
  } //end for each triangle
  glEnable(GL_BLEND);
}


void drawValley2old()
{
/*	Render everything or render front, update depth buffer
	Render extra stuff from front face, set stencil where z-passes
	Render back
	Render extra stuff from front face, where stencil not set
	*/

	// Step 1
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT | GL_STENCIL_BUFFER_BIT);
    glStencilFunc (GL_ALWAYS, 0x1, 0x1);
    glStencilOp (GL_KEEP, GL_KEEP, GL_KEEP);
	glColor3f(1.0,1.0,0.0);
	glEnable(GL_CULL_FACE);
    glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
    gluPerspective(FOV, (float) winWidth/winHeight,1.0,ZFAR);
    glMatrixMode(GL_MODELVIEW);
	if (sharpFlag) drawSharps(); else drawFront();
	glDisable(GL_CULL_FACE);
	glColorMask(GL_FALSE, GL_FALSE, GL_FALSE, GL_FALSE);

	// Step 2
    glClearStencil(0x1);
    glEnable(GL_STENCIL_TEST);

    glStencilFunc (GL_ALWAYS, 0x1, 0x1);
    glStencilOp (GL_KEEP, GL_KEEP, GL_INCR);

	glColor3f(1.0,0,0);
	glDepthMask(GL_FALSE);
	glEnable(GL_CULL_FACE);
	drawExtraStuff(1.0);
	glDisable(GL_CULL_FACE);
	glDepthMask(GL_TRUE);
	
	// Step 3
    glClear(GL_DEPTH_BUFFER_BIT);
    glStencilOp (GL_KEEP, GL_KEEP, GL_KEEP);
    glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
//	glTranslatef(0,0,0.0001);
	glTranslatef(0,0,offset_units*0.0001);
    gluPerspective(FOV, (float) winWidth/winHeight,1.0,ZFAR);
	//glTranslatef(0,0,offset_units);
    glMatrixMode(GL_MODELVIEW);
	drawFront();
    glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
    gluPerspective(FOV, (float) winWidth/winHeight,1.0,ZFAR);
    glMatrixMode(GL_MODELVIEW);
	glDisable(GL_CULL_FACE);
	// drawBackFattened;
	 drawBackSimple();
	// drawBack();

//    glClear(GL_COLOR_BUFFER_BIT); 
	// Step 4
    glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
    gluPerspective(FOV, (float) winWidth/winHeight,1.0,ZFAR);
    glMatrixMode(GL_MODELVIEW);
    glStencilFunc (GL_ALWAYS, 0x1, 0x1);
    glStencilOp (GL_KEEP, GL_KEEP, GL_DECR);
	glDepthMask(GL_FALSE);
	glEnable(GL_CULL_FACE);
	drawExtraStuff(1.0);
	glDisable(GL_CULL_FACE);
	glColorMask(GL_TRUE, GL_TRUE, GL_TRUE, GL_TRUE);
    glStencilFunc (GL_EQUAL, 0x0, 0x1);
    glStencilOp (GL_KEEP, GL_KEEP, GL_KEEP);
	glEnable(GL_CULL_FACE);
	drawExtraStuff(1.0);
	glDisable(GL_CULL_FACE);
    glClear(GL_STENCIL_BUFFER_BIT); 
	glDepthMask(GL_TRUE);
    glDisable(GL_STENCIL_TEST);
}

void drawValley2()
{
/*	Render everything or render front, update depth buffer
	Render extra stuff from front face, set stencil where z-passes
	Render back
	Render extra stuff from front face, where stencil not set
	*/

	// Step 1
    // glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT | GL_STENCIL_BUFFER_BIT);
    glStencilFunc (GL_ALWAYS, 0x1, 0x1);
    glStencilOp (GL_KEEP, GL_KEEP, GL_KEEP);
	glColor3f(1.0,1.0,0.0);
	glEnable(GL_CULL_FACE);
    glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
    gluPerspective(FOV, (float) winWidth/winHeight,1.0,ZFAR);
    glMatrixMode(GL_MODELVIEW);
	if (sharpFlag) { drawsilhouetteBackFattened(); drawSharps();} else drawFront();
	glDisable(GL_CULL_FACE);
	glColorMask(GL_FALSE, GL_FALSE, GL_FALSE, GL_FALSE);

	// Step 2
    glClearStencil(0x1);
    glEnable(GL_STENCIL_TEST);

    glStencilFunc (GL_ALWAYS, 0x1, 0xFF);
    glStencilOp (GL_KEEP, GL_KEEP, GL_INCR);

	glColor3f(1.0,0,0);
	glDepthMask(GL_FALSE);
	glEnable(GL_CULL_FACE);
	drawExtraStuff(1.0);
	glDisable(GL_CULL_FACE);
	glDepthMask(GL_TRUE);
	
	// Step 3
    glClear(GL_DEPTH_BUFFER_BIT);
    glStencilOp (GL_KEEP, GL_KEEP, GL_KEEP);
    glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
//	glTranslatef(0,0,0.0001);
	glTranslatef(0,0,offset_units*0.0001);
    gluPerspective(FOV, (float) winWidth/winHeight,1.0,ZFAR);
	//glTranslatef(0,0,offset_units);
    glMatrixMode(GL_MODELVIEW);
	 drawFront();
    glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
    gluPerspective(FOV, (float) winWidth/winHeight,1.0,ZFAR);
    glMatrixMode(GL_MODELVIEW);
	glDisable(GL_CULL_FACE);
	// drawBackFattened;
	// drawBackSimple();
	// drawBack();

//    glClear(GL_COLOR_BUFFER_BIT); 
	// Step 4
	glDepthFunc(GL_LESS);
    glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
    gluPerspective(FOV, (float) winWidth/winHeight,1.0,ZFAR);
    glMatrixMode(GL_MODELVIEW);
    glStencilFunc (GL_ALWAYS, 0x1, 0xFF);
    glStencilOp (GL_KEEP, GL_KEEP, GL_DECR);
	glDepthMask(GL_FALSE);
	glEnable(GL_CULL_FACE);
	drawExtraStuff(1.0);
	glDisable(GL_CULL_FACE);
	glColorMask(GL_TRUE, GL_TRUE, GL_TRUE, GL_TRUE);
    glStencilFunc (GL_EQUAL, 0x0, 0xFF);
    glStencilOp (GL_KEEP, GL_KEEP, GL_KEEP);
	glEnable(GL_CULL_FACE);
	//drawExtraStuff(1.0);
	glColor3f(0.0,0,0.2);
	drawFront();
	glDisable(GL_CULL_FACE);
    glClear(GL_STENCIL_BUFFER_BIT); 
	glDepthMask(GL_TRUE);
    glDisable(GL_STENCIL_TEST);
	glDepthFunc(GL_LEQUAL);

}

void drawIntersect()
{
/*  Render front shifted back
    Render front, incrementing when z passes
	Wherever stencil = 2, is the intersection, just draw big rect
*/
	static int shiftCount = 100;

    // glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT | GL_STENCIL_BUFFER_BIT);
    glStencilFunc (GL_ALWAYS, 0x1, 0x1);
    glStencilOp (GL_KEEP, GL_KEEP, GL_KEEP);
    glDisable(GL_STENCIL_TEST);
	glEnable(GL_CULL_FACE);
    glEnable(GL_DEPTH_TEST);
	glDepthFunc(GL_LEQUAL);
	glDepthMask(GL_TRUE);
	glColor3f(1.0,0.0,0.0);
    glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	glTranslatef(0,0,offset_units*0.0001);
    gluPerspective(FOV, (float) winWidth/winHeight,1.0,ZFAR);
    glMatrixMode(GL_MODELVIEW);
	drawFront(); glPushMatrix(); glTranslatef(shiftCount, 20+shiftCount/5.0 , 0); glRotatef(50,1,0,0); drawFront(); glPopMatrix();
	//drawSharps(); glPushMatrix(); glTranslatef(shiftCount, shiftCount/5.0 , 0); drawSharps(); glPopMatrix();
	//drawsilhouetteBackFattened(); glPushMatrix(); glTranslatef(shiftCount, shiftCount/5.0 , 0); drawsilhouetteBackFattened(); glPopMatrix();

    glClearStencil(0x0);
    glClear(GL_STENCIL_BUFFER_BIT); 
    glEnable(GL_STENCIL_TEST);
    glStencilFunc (GL_ALWAYS, 0x1, 0xFF);
    glStencilOp (GL_KEEP, GL_KEEP, GL_INCR);
	glDepthMask(GL_FALSE);
	glColor3f(1.0,1.0,0.0);
    glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
    gluPerspective(FOV, (float) winWidth/winHeight,1.0,ZFAR);
    glMatrixMode(GL_MODELVIEW);
	//drawFront();
	//drawFront(); glPushMatrix(); glTranslatef(shiftCount, 20+shiftCount/5.0 , 0); drawFront(); glPopMatrix();
	//drawSharps(); glPushMatrix(); glTranslatef(shiftCount, 20+shiftCount/5.0, 0); drawSharps(); glPopMatrix();
	drawsilhouetteBackFattened(); glPushMatrix(); glTranslatef(shiftCount, 20+shiftCount/5.0 , 0); glRotatef(50,1,0,0); drawsilhouetteBackFattened(); glPopMatrix();
	glDepthMask(GL_TRUE);

    glStencilFunc (GL_EQUAL, 2, 0xFF);
    //glStencilFunc (GL_ALWAYS, 0x1, 0xFF);
    glStencilOp (GL_KEEP, GL_KEEP, GL_KEEP);
	glColor3f(0.0,0.0,1.0);
    glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	glTranslatef(0,0,-offset_units*0.0001);
    gluPerspective(FOV, (float) winWidth/winHeight,1.0,ZFAR);
    glMatrixMode(GL_MODELVIEW);
	//drawFront();
	drawFront(); glPushMatrix(); glTranslatef(shiftCount, 20+shiftCount/5.0 , 0); glRotatef(50,1,0,0); /*drawFront();*/ glPopMatrix();
	//drawSharps(); glPushMatrix(); glTranslatef(shiftCount, 20+shiftCount/5.0, 0); drawSharps(); glPopMatrix();
	//drawsilhouetteBackFattened(); glPushMatrix(); glTranslatef(shiftCount, shiftCount/5.0 , 0); drawsilhouetteBackFattened(); glPopMatrix();
	shiftCount-= 1; if (shiftCount == -100) shiftCount = 100;

    glDisable(GL_STENCIL_TEST);
}

void drawValleyIntersect()
{
/*	Render everything or render front, update depth buffer
	Render extra stuff from front face, set stencil where z-passes
	Render back
	Render extra stuff from front face, where stencil not set
	*/

	// Step 1
    // glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT | GL_STENCIL_BUFFER_BIT);
    glStencilFunc (GL_ALWAYS, 0x1, 0x1);
    glStencilOp (GL_KEEP, GL_KEEP, GL_KEEP);
	glColor3f(1.0,1.0,0.0);
	glEnable(GL_CULL_FACE);
    glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
    gluPerspective(FOV, (float) winWidth/winHeight,1.0,ZFAR);
    glMatrixMode(GL_MODELVIEW);
	if (sharpFlag) drawSharps(); else drawFront();
	glDisable(GL_CULL_FACE);
	glColorMask(GL_FALSE, GL_FALSE, GL_FALSE, GL_FALSE);

	// Step 2
    glClearStencil(2);
    glEnable(GL_STENCIL_TEST);

    glStencilFunc (GL_ALWAYS, 0x1, 0xFF);
    glStencilOp (GL_KEEP, GL_KEEP, GL_INCR);

	glColor3f(1.0,0,0);
	glDepthMask(GL_FALSE);
	glEnable(GL_CULL_FACE);
	drawExtraStuff(1.0);
	glDisable(GL_CULL_FACE);
	glDepthMask(GL_TRUE);
	
	// Step 3
    glClear(GL_DEPTH_BUFFER_BIT);
    glStencilOp (GL_KEEP, GL_KEEP, GL_KEEP);
    glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
//	glTranslatef(0,0,0.0001);
	glTranslatef(0,0,offset_units*0.0001);
    gluPerspective(FOV, (float) winWidth/winHeight,1.0,ZFAR);
	//glTranslatef(0,0,offset_units);
    glMatrixMode(GL_MODELVIEW);
	 drawFront();
    glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
    gluPerspective( FOV, (float) winWidth/winHeight, 1.0,ZFAR);
    glMatrixMode(GL_MODELVIEW);
	glDisable(GL_CULL_FACE);
	// drawBackFattened;
	// drawBackSimple();
	// drawBack();

//    glClear(GL_COLOR_BUFFER_BIT); 
	// Step 4
	glDepthFunc(GL_LESS);
    glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
    gluPerspective( FOV, (float) winWidth/winHeight, 1.0,ZFAR);
    glMatrixMode(GL_MODELVIEW);
    glStencilFunc (GL_ALWAYS, 0x1, 0xFF);
    glStencilOp (GL_KEEP, GL_KEEP, GL_DECR);
	glDepthMask(GL_FALSE);
	glEnable(GL_CULL_FACE);
	drawFront();drawExtraStuff(1.0);
	glDisable(GL_CULL_FACE);
	glColorMask(GL_TRUE, GL_TRUE, GL_TRUE, GL_TRUE);
    glStencilFunc (GL_EQUAL, 0x0, 0xFF);
    glStencilOp (GL_KEEP, GL_KEEP, GL_KEEP);
	glEnable(GL_CULL_FACE);
	glColor3f(0.0,0,0);
	drawFront();
	glDisable(GL_CULL_FACE);
    glClear(GL_STENCIL_BUFFER_BIT); 
	glDepthMask(GL_TRUE);
    glDisable(GL_STENCIL_TEST);
	glDepthFunc(GL_LEQUAL);
}

